## Abstraktni trida obsahujici spolecne dekoratory pro GuidepostCell a OsmGuidepostCell

class CommonGuidepostCell < Cell::ViewModel  
  property :nazev
  property :trails
  property :kctref
  
  include ApplicationHelper  # for link_to_not_nil in brief_links_to_related
  include MapHelper  # for map scripts
  include OsmHelper # for osm_node_url in attribute_nazev view
  include PresentationHelper # attribute helper
  
#   include Application::Controllers::Helpers
#   helper_method :current_user

  def show; link_to common_guidepost end

  def trails_icons_links(skip_trails: [])   # pro všechny trailsy - ikonka s linkem
    render locals: {show_trails: (common_trails - skip_trails) }
  end

  def nazev_or_kct_nazev;  nazev || render end
  def nazev_or_dbf_nazev;  nazev || render end
  def nazev_or_na; nazev.blank? ? "N/A" : nazev end
  def nazev_or_na_link;        link_to(nazev_or_na, common_guidepost) end
  def nazev_or_kct_nazev_link; link_to(nazev_or_kct_nazev, common_guidepost) end

  def kct_nazev_kct_link
    link_if_not_nil(model.kct_guidepost.andand.nazev, model.kct_guidepost)
  end
  def qad_nazev_qad_link
    naz = model.guidepost.andand.nazev
    naz = 'bez názvu' if naz.blank?
    link_if_not_nil( naz, model.guidepost)
  end
  
  def map;  render end
    
  def kctref_link                           # První KČTref s linkem, pokud jich je víc dá tam +
    kctrefs = common_guidepost.kctrefs
    label = case kctrefs.size
              when 0 then '?????'
              when 1 then kctrefs.first
              else kctrefs.first+'+'
    end
    link_to(label, common_guidepost)
  end

  def kctrefs_link                           # KČTref s linkem, pokud jich je víc dá tam všechny
    link_to(common_guidepost.kctref || '?????', common_guidepost)
  end

  def nazev_kctref_link                   # Název a KČTref s linkem
    linked_text = common_guidepost.nazev || 'bez názvu'
    linked_text += "(#{common_guidepost.kctref})"  if common_guidepost.kctref
    link_to(linked_text, common_guidepost)
  end
  
  # číselná hodnota výšky nad mořem. pokud je to , hodnota se skyje
  def vyska
    (model.vyska == 0) ? '' : model.vyska  
  end
  
  # jednoznakové odkazy na related guideposty
  def brief_links_to_related;  render end
  
  # řádky do tabulky atributů (viz např. guidepost#show apod)
  def attribute_nazev;       render end
  def attribute_ref;         render end
  def attribute_umisteni;    render end
    
  def attribute_nazev_aside
    result = []
    linked_guideposts.each do |label, object| 
      result << label
      if label=='OSM'
        result << link_to(object.nazev || 'N/A', object) + ' ' + link_if_not_nil('🔗', osm_node_url(model.osmid))
      else
        result << link_to(object.nazev || 'N/A', object)
      end
    end
    result   
#     link_if_not_nil(model.osm_guidepost.andand.nazev, model.osm_guidepost) + ' ' +
#     ,
#  'SEZ',   link_if_not_nil(model.sez_guidepost.andand.nazev, model.sez_guidepost) 
#   ]    
  end
      
  private
  alias :common_guidepost :model
  alias :cguidepost :model
  def common_trails;  raise NotImplementedError, 'Redefine this in children' end

  def linked_guideposts
    result = {}
    result['QAK'] = model.guidepost unless model.is_a? Guidepost or model.guidepost.nil?
    result['KČT'] = model.kct_guidepost unless model.is_a? KctGuidepost or model.kct_guidepost.nil?
    result['OSM'] = model.osm_guidepost unless model.is_a? OsmGuidepost or model.osm_guidepost.nil?
    result['SEZ'] = model.sez_guidepost unless model.is_a? SezGuidepost or model.sez_guidepost.nil?
    result.compact
  end
    
end
